(use-modules (oop goops) (mod1) (mod2))
(use-modules ((mod1-primitive) :renamer (symbol-prefix-proc 'primitive:)))
(use-modules ((mod2-primitive) :renamer (symbol-prefix-proc 'primitive:)))

(define (!= foo b) (not (= foo b)))

(define (testFoo foo initval)
  (if (!= (primitive:Foo-a-get foo) initval)  (display "Test 1 failed") )
  (primitive:Foo-a-set foo (+ initval 1))
  (if (!= (primitive:Foo-a-get foo) (+ initval 1))  (display "Test 2 failed") )
  (set! (primitive:Foo-a foo) (+ initval 2))
  (if (!= (primitive:Foo-a foo) (+ initval 2))  (display "Test 3 failed") ))

(define (testGoopsFoo foo initval)
  (if (!= (a foo) initval)  (display "Test 4 failed") )
  (set! (a foo) (+ initval 1))
  (if (!= (a foo) (+ initval 1))  (display "Test 5 failed") ))

(define (testBar bar initval fooinitval)
  (if (!= (primitive:Bar-getInt bar) initval)  (display "Test 6 failed") )
  (testFoo (primitive:Bar-getFoo bar) fooinitval))

(define (testGoopsBar bar initval fooinitval)
  (if (!= (getInt bar) initval)  (display "Test 8 failed") )
  (testGoopsFoo (getFoo bar) fooinitval))

(define (testOops oops initval)
  (if (!= (primitive:Oops-c-b-get oops) initval)  (display "Test 10 failed") )
  (primitive:Oops-c-c-set oops 4)
  (if (!= (primitive:Oops-c-c-get oops) 4)  (display "Test 11 failed") )
  (if (!= (primitive:Oops-c-b oops) initval)  (display "Test 12 failed") )
  (set! (primitive:Oops-c-c oops) 5)
  (if (!= (primitive:Oops-c-c oops) 5)  (display "Test 13 failed") ))

(define (testGoopsOops oops initval)
  (if (!= (b oops) initval)  (display "Test 14 failed") )
  (set! (c oops) 4)
  (if (!= (c oops) 4)  (display "Test 15 failed") ))

(define (testJoo joo initval)
  (if (!= (primitive:Joo-getInt joo) initval)  (display "Test 16 failed") )
  (primitive:Joo-mult-by joo 2)
  (if (!= (primitive:getJooInt joo) (* initval 2))  (display "Test 17 failed") )
  (testBar joo (* initval 2) (* initval 10))
  (testBar (primitive:JooToBar joo 2) (* initval 4) (* initval 10))
  (testOops joo (* initval 100)))

(define (testGoopsJoo joo initval)
  (if (!= (getInt joo) initval)  (display "Test 18 failed") )
  (mult-by joo 2)
  (if (!= (getJooInt joo) (* initval 2))  (display "Test 19 failed") )
  (testGoopsBar joo (* initval 2) (* initval 10))
  (testGoopsBar (JooToBar joo 2) (* initval 4) (* initval 10))
  (testGoopsOops joo (* initval 100)))

(define (testOther other initval)
  (if (!= (primitive:OtherModule-get other) initval) (display "Test 20 failed"))
  (if (!= (primitive:getIntFunction other) (* initval 2)) (display "Test 21 failed"))
  (testFoo (primitive:OtherModule-goodbye-get other) (* initval 100))
  (testFoo (primitive:OtherModule-goodbye other) (+ (* initval 100) 2))
  (testFoo (primitive:OtherModule-good other) (+ (* initval 100) 4))
  (testJoo other (* initval 2))
  (primitive:OtherModule-goodbye-set other (primitive:new-Goodbye 6))
  (testFoo (primitive:OtherModule-goodbye other) 6)
  (set! (primitive:OtherModule-goodbye other) (primitive:new-Goodbye 8))
  (testFoo (primitive:OtherModule-goodbye-get other) 8)
  (testFoo (primitive:getHelloo other 24) 24))

(define (testGoopsOther other initval)
  (if (!= (get other) initval) (display "Test 21 failed"))
  (if (!= (getIntFunction other) (* initval 2)) (display "Test 22 failed"))
  (testGoopsFoo (goodbye other) (* initval 100))
  (testGoopsFoo (good other) (+ (* initval 100) 1))
  (testGoopsJoo other (* initval 2))
  (set! (goodbye other) (make <Goodbye> #:args '(6)))
  (testGoopsFoo (slot-ref other 'goodbye) 6)
  (testGoopsFoo (getHelloo other 27) 27))

(testFoo (primitive:new-Foo 10) 10)
(testGoopsFoo (make <Foo> #:args '(10)) 10)
(testBar (primitive:new-Bar 15) 15 15)
(testGoopsBar (make <Bar> #:args '(16)) 16 16)
(testFoo (primitive:new-Goodbye 10) 10)
(testGoopsFoo (make <Goodbye> #:args '(10)) 10)
(testOops (primitive:new-Oops-c 3) 3)
(testGoopsOops (make <Oops-c> #:args '(6)) 6)
(testJoo (primitive:new-Joo 6) 6)
(testGoopsJoo (make <Joo> #:args '(8)) 8)
(testJoo (primitive:new-Joo) 13)
(testGoopsJoo (make <Joo>) 13)
(testOther (primitive:new-OtherModule 7) 7)
(testGoopsOther (make <OtherModule> #:args '(7)) 7)

(testJoo (primitive:globalJoo) 13)
(testGoopsJoo (globalJoo) 13)
(primitive:globalJoo (primitive:new-Joo 18))
(testJoo (primitive:globalJoo) 18)
(set! (globalJoo) (make <Joo> #:args '(4)))
(testGoopsJoo (globalJoo) 4)
